<?php

namespace Was\Smartcash\Controller\Payment;

use Magento\Checkout\Model\Session;
use Magento\Framework\App\Action\Context;
use Magento\Framework\Controller\ResultFactory;

class Error extends \Magento\Framework\App\Action\Action {
    
    /**
     * @var \Magento\Checkout\Model\Session
     */
    private $_checkoutSession;
    
    /**
     * @var \Magento\Framework\View\Result\PageFactory
     */
    private $_resultPageFactory;
    
    /**
     * @var \Magento\Store\Model\StoreManagerInterface
     */
    private $_storeManager;
    
    /**
     * @var \Psr\Log\LoggerInterface
     */
    protected $_logger;
    
    /**
     * @var \Switchpay\Paymentgateway\Model\TransactionFactory
     */
    protected $_transactionFactory;
    
    /**
     * 
     * @param Context $context
     * @param Session $checkoutSession
     * @param \Magento\Framework\View\Result\PageFactory $resultPageFactory
     * @param \Magento\Store\Model\StoreManagerInterface $storeManager
     * @param \Psr\Log\LoggerInterface $logger
     * @param \Switchpay\Paymentgateway\Model\TransactionFactory $transactionFactory
     */
    public function __construct(
        Context $context,
        Session $checkoutSession,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory,
        \Magento\Store\Model\StoreManagerInterface $storeManager,
        \Psr\Log\LoggerInterface $logger,
        \Was\Smartcash\Model\TransactionFactory $transactionFactory
    ) {
        parent::__construct($context);
        $this->_checkoutSession = $checkoutSession;
        $this->_resultPageFactory = $resultPageFactory;
        $this->_storeManager = $storeManager;
        $this->_logger = $logger;
        $this->_transactionFactory = $transactionFactory;
    }
    
    public function execute(){
        $smartcashResponse = $this->getRequest()->getParams();
        //echo "<pre>"; print_r($smartcashResponse);die('here');
        if(isset($smartcashResponse['orderNumber'])){
            $transactionLog = $this->_transactionFactory->create()->getCollection()
                ->addFieldToFilter('merchant_transaction_id', $smartcashResponse['orderNumber'])
                ->setOrder('entity_id','DESC')
                ->getFirstItem();
            $transactionLog->setStatus();
            $transactionLog->save();
        }
        $cartUrl = 'checkout/cart';
        $this->messageManager->addErrorMessage(__('Transaction declined.'));
        $resultRedirect = $this->resultFactory->create(ResultFactory::TYPE_REDIRECT);
        return $resultRedirect->setPath($cartUrl, ['_secure' => true]);
    }
    
    public function getQuote() {
        return $this->_checkoutSession->getQuote();
    }
}