<?php

namespace Was\Smartcash\Controller\Payment;

use Magento\Framework\App\Action\Context;
use Magento\Framework\Controller\Result\JsonFactory;
use Magento\Checkout\Model\Session;

class LoadInfo extends \Magento\Framework\App\Action\Action {
    /**
     * @var JsonFactory $resultJsonFactory
     */
    private $_resultJsonFactory;
    
    /**
     * @var \Magento\Framework\Data\Form\FormKey\Validator
     */
    private $_formKeyValidator;
    
    /**
     * @var Session
     */
    private $_session;
    
    /**
     * @var \Magento\Quote\Api\CartRepositoryInterface
     */
    private $_quoteRepository;
    
    /**
     * @var \Payment\Asiahawala\Helper\Data
     */
    private $_helper;
    
    /**
     * @param Context $context
     * @param JsonFactory $resultJsonFactory
     * @param \Magento\Framework\Data\Form\FormKey\Validator $formKeyValidator
     * @param Session $session
     * @param \Magento\Quote\Api\CartRepositoryInterface $quoteRepository
     * @param \Payment\Asiahawala\Helper\Data $helper
     */
    
    public function __construct(
        Context $context,
        JsonFactory $resultJsonFactory,
        \Magento\Framework\Data\Form\FormKey\Validator $formKeyValidator,
        Session $session,
        \Magento\Quote\Api\CartRepositoryInterface $quoteRepository,
        \Was\Smartcash\Helper\Data $helper
    ) {
        $this->_resultJsonFactory = $resultJsonFactory;
        $this->_session = $session;
        $this->_formKeyValidator = $formKeyValidator;
        parent::__construct($context);
        $this->_quoteRepository = $quoteRepository;
        $this->_helper = $helper;
    }
    
    public function execute(){
        $result = $this->_resultJsonFactory->create();
        $quote = $this->_session->getQuote();
        //echo $quoteid = $quote->getId();exit;
        if (!$this->_formKeyValidator->validate($this->getRequest())) {
            //return $result->setData(['error' => __('Invalid formkey.')]);
        }
        if ($guestEmail = $this->_request->getParam('quoteEmail')) {
            $quote->setCustomerEmail($guestEmail);
        }
        $quote->reserveOrderId();
        $this->_quoteRepository->save($quote);
        
        $data = [];
        
        try {
            $data = $this->_helper->buildRequest();
        } catch (\Exception $e) {
            $data['error'] = $e->getMessage();
        }

        $result->setData($data);
        return $result;
    }
}
