<?php

/**
 * @Author Was
 */

namespace Was\Smartcash\Setup;

use Magento\Framework\Setup\InstallSchemaInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\SchemaSetupInterface;
use Magento\Framework\DB\Ddl\Table;

//@codingStandardsIgnoreFile

/**
 * @codeCoverageIgnore
 */
class InstallSchema implements InstallSchemaInterface {

    const TABLE = 'smartcash_payment_transaction';

    /**
     * {@inheritdoc}
     */
    public function install(SchemaSetupInterface $setup, ModuleContextInterface $context) {
        $setup->startSetup();

        $transactionTable = $setup->getTable(self::TABLE);

        if (!$setup->tableExists($transactionTable)) {
            $table = $setup->getConnection()->newTable(
                $setup->getTable(self::TABLE)
                )->addColumn('entity_id', Table::TYPE_INTEGER, null, [
                    'identity' => true,
                    'unsigned' => true,
                    'nullable' => false,
                    'primary' => true,
                        ], 'Entity Id'
                )->addColumn(
                    'merchant_transaction_id', Table::TYPE_TEXT, 255, ['nullable' => true], 'Merchant Transaction Id'
                )->addColumn(
                    'payment_order_id', Table::TYPE_TEXT, 255, ['nullable' => true], 'Payment Order Id'
                )->addColumn(
                    'status', Table::TYPE_TEXT, 255, ['nullable' => true], 'Status'
                )->addColumn(
                    'amount', Table::TYPE_TEXT, 255, ['nullable' => true], 'Amount'
                )->addColumn(
                    'quote_id', Table::TYPE_INTEGER, null, ['nullable' => true], 'Quote Id'
                )->addColumn(
                    'customer_email', Table::TYPE_TEXT, 255, ['nullable' => true], 'Customer Email'
                )->addColumn(
                    'order_id', Table::TYPE_TEXT, 255, ['nullable' => true], 'Order Id'
                )->addColumn(
                    'all_response', Table::TYPE_TEXT, '2M', ['nullable' => true], 'All Response'
                )->addColumn(
                    'error_message', Table::TYPE_TEXT, 255, ['nullable' => true], 'Error Message'
                )->addColumn(
                    'created_at', Table::TYPE_TIMESTAMP, null, ['nullable' => false, 'default' => Table::TIMESTAMP_INIT], 'Created At'
                )->addColumn(
                    'updated_at', Table::TYPE_TIMESTAMP, null, ['nullable' => false, 'default' => Table::TIMESTAMP_INIT_UPDATE], 'Updated At'
                );
                $setup->getConnection()->createTable($table);
        }
        $setup->endSetup();
    }

}
