define(
    [
        'jquery',
        'Magento_Checkout/js/view/payment/default',
        'Magento_Checkout/js/action/redirect-on-success',
        'Magento_Paypal/js/action/set-payment-method',
        'Magento_Checkout/js/model/payment/additional-validators',
        'Magento_Customer/js/customer-data',
        'mage/url',
        'Magento_Checkout/js/model/quote',
        'Magento_Checkout/js/model/full-screen-loader',
        'mage/url',
        'Magento_Checkout/js/action/set-payment-information',
    ],
    function ($, Component, redirectOnSuccessAction, setPaymentMethodAction, additionalValidators, customerData, url, quote, fullScreenLoader, urlBuilder, setPaymentInformationAction
            ) {
        'use strict';
        return Component.extend({
            defaults: {
                template: 'Was_Smartcash/payment/smartcash',
                code: 'smartcash',
            },
            getCode: function () {
                return this.code;
            },
            handleError: function (data) {
                var message = (data && data.error) ? data.error :  $.mage.__('An error occurred.');
                this.messageContainer.addErrorMessage({message: message});
                fullScreenLoader.stopLoader();
            },
            createHiddenInput: function (name, value) {
                return $('<input type="hidden" />').attr('name', name).attr('value', value );
            },
            continueToSmartcash: function () {
                fullScreenLoader.startLoader();
                if (additionalValidators.validate()) {
                    this.selectPaymentMethod();
                    var queryString = {form_key: $.cookie('form_key')};
                    queryString.quoteId = quote.id;
                    if (quote.guestEmail) {
                        queryString.quoteEmail = quote.guestEmail;
                    }
                    $.when(
                        setPaymentInformationAction(this.messageContainer, {method: this.getCode()})
                        ).then(
                        function () {
                            return $.ajax({
                                url: urlBuilder.build("smartcash/payment/loadinfo"),
                                type: "post",
                                dataType: 'json',
                                data: queryString
                            })
                        }
                    ).done(
                        function (data) {
                            console.log(data);
                            if (!data || data.success==false) {
                                return this.handleError(data.message);
                            }
                            else{
                                window.location.replace(data.formUrl);
                            }
                            
                        }.bind(this)
                    ).always(
                        function () {
                            fullScreenLoader.stopLoader();
                        }
                    );
                    /*setPaymentMethodAction(this.messageContainer).done(
                     function () {
                     customerData.invalidate(['cart']);
                     //$.mage.redirect(url.build('asiahawala/payment/redirect'));
                     }
                     );*/

                    return false;
                }
            }
        });
    }
);